
package de.ivu.elect.presentation.entschaedigung.menu;

import javax.inject.Inject;

import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungExtendedDAO;
import de.ivu.elect.business.entschaedigung.entity.EntschaedigungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.boundary.WahlterminSessionSelect;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public abstract class AbstractEntschaedigungMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  protected transient WahlSessionSelect wahlSelect;

  @Inject
  protected transient WahlterminSessionSelect wahlterminSelect;

  @Inject
  protected transient EntschaedigungExtendedDAO entschaedigungDAO;

  @Inject
  protected transient EntschaedigungMeta entschaedigungMeta;

  public AbstractEntschaedigungMenuItemEntry() {
    super();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(getUseCasePermission());
  }

  protected abstract UseCasePermission getUseCasePermission();

  @Override
  public boolean isDisabledInternal() {
    return !wahlSelect.isSelected() && !wahlterminSelect.isSelected();
  }

  protected EntschaedigungMeta getMeta() {
    return entschaedigungMeta;
  }
}
